from phi.agent import Agent
from phi.model.ollama import Ollama
from phi.embedder.ollama import OllamaEmbedder
from phi.knowledge.pdf import PDFKnowledgeBase
from phi.vectordb.lancedb import LanceDb, SearchType

# Create a knowledge base from a PDF
knowledge_base = PDFKnowledgeBase(
    path="/Users/chenyang/Desktop/annolid/annolid/agents/assets/2403.18690v1.pdf",
    # Use LanceDB as the vector database
    vector_db=LanceDb(
        table_name="recipes",
        uri="lancedb",
        search_type=SearchType.vector,
        embedder=OllamaEmbedder(model="mxbai-embed-large"),
    ),
)
# Comment out after first run as the knowledge base is loaded
knowledge_base.load()

agent = Agent(
    model=Ollama(id="llama3.2"),
    # Add the knowledge base to the agent
    knowledge=knowledge_base,
    show_tool_calls=True,
    markdown=True,
    debug_mode=True,
)
agent.print_response("How do I track mutliple aniamls?", stream=True)
